function setTitle(t) {
	document.title = t;
	if(opera && opera.contexts && opera.contexts.speeddial)
		opera.contexts.speeddial.title = t;
}
function setUrl(u) {
	if(opera && opera.contexts && opera.contexts.speeddial)
		opera.contexts.speeddial.url = u;
}

function cbfunc(q) {
	document.body.className = 'untitled';
	
	q = q.query;
	if(q.count != 1) {
		document.body.innerHTML = "<div id='err'><i>Brak wiersza do wyświetlenia.</i></div>";
		return;
	}
	
	q = q.results.item;
	if(q.title) {
		setTitle(q.title);
		var h1 = document.createElement('h1');
		h1.textContent = q.title;
		
		if(q.copyright && q.copyright.content) {
			var author = q.copyright.content.substr(15);
			var span = document.createElement('span');
			if(q.copyright.url) {
				span.textContent = " by ";
				var a = document.createElement('a');
				a.href = q.copyright.url;
				a.textContent = author;
				span.appendChild(a);
			} else {
				span.textContent = " by " + author;
			}
			h1.appendChild(span);
		}
		
		document.body.appendChild(h1);
		document.body.className = 'titled';
	}
	if(q.link) setUrl(q.link);
	
	var html = q.text.content.replace(' - ', ' &ndash; ');
	html = "<p>" + html.replace(/<br\s*\/?>/gi, "</p><p>") + "</p>";
	
	var div = document.createElement('div');
	div.innerHTML = html;
	document.body.appendChild(div);
}

function onload() {
	var script = document.createElement('script');
	script.type = 'text/javascript';
	var url = "http://backend.deviantart.com/rss.xml?q=" + escape(widget.preferences.q) + "&type=deviation";
	var q = "SELECT title,link,text,copyright FROM rss WHERE url='" + url + "' AND text IS NOT NULL LIMIT 1";
	script.src = "http://query.yahooapis.com/v1/public/yql?q=" + escape(q) + "&format=json&callback=cbfunc";
	document.head.appendChild(script);
	
	if(widget){
		q = String(widget.preferences.q);
		var i=0;
		setInterval(function(){
			if(widget.preferences.q != q)
				location.reload();
		}, 200);
	}
}
